import { Network, Platform } from "@wormhole-foundation/sdk-base";
import { TokenAddress, ChainAddress, NativeAddress, RpcConnection, TokenBridge, UnsignedTransaction } from "../..";
import { PlatformToChains } from "@wormhole-foundation/sdk-base/src";
export declare class MockTokenBridge<N extends Network, P extends Platform, C extends PlatformToChains<P>> implements TokenBridge<N, P, C> {
    readonly rpc: RpcConnection<P>;
    constructor(rpc: RpcConnection<P>);
    isWrappedAsset(token: TokenAddress<C>): Promise<boolean>;
    getOriginalAsset(token: TokenAddress<C>): Promise<ChainAddress>;
    hasWrappedAsset(original: ChainAddress): Promise<boolean>;
    getWrappedAsset(original: ChainAddress): Promise<NativeAddress<C>>;
    isTransferCompleted(vaa: TokenBridge.VAA<"Transfer" | "TransferWithPayload">): Promise<boolean>;
    createAttestation(address: TokenAddress<C>): AsyncGenerator<UnsignedTransaction<N, C>>;
    submitAttestation(vaa: TokenBridge.VAA<"AttestMeta">): AsyncGenerator<UnsignedTransaction<N, C>>;
    transfer(sender: TokenAddress<C>, recipient: ChainAddress, token: TokenAddress<C>, amount: bigint, payload?: Uint8Array | undefined): AsyncGenerator<UnsignedTransaction<N, C>>;
    redeem(sender: TokenAddress<C>, vaa: TokenBridge.VAA<"Transfer" | "TransferWithPayload">, unwrapNative?: boolean | undefined): AsyncGenerator<UnsignedTransaction<N, C>>;
    getWrappedNative(): Promise<NativeAddress<C>>;
}
//# sourceMappingURL=tokenBridge.d.ts.map