import { Chain, Platform, ChainToPlatform } from "@wormhole-foundation/sdk-base";
import { UniversalAddress } from "./universalAddress";
export interface Address {
    unwrap(): unknown;
    toString(): string;
    toUint8Array(): Uint8Array;
    toUniversalAddress(): UniversalAddress;
}
declare global {
    namespace Wormhole {
        interface PlatformToNativeAddressMapping {
        }
    }
}
export type MappedPlatforms = keyof Wormhole.PlatformToNativeAddressMapping;
type ChainOrPlatformToPlatform<T extends Chain | Platform> = T extends Chain ? ChainToPlatform<T> : T;
type GetNativeAddress<T extends Platform> = T extends MappedPlatforms ? Wormhole.PlatformToNativeAddressMapping[T] : never;
export type NativeAddress<T extends Platform | Chain> = GetNativeAddress<ChainOrPlatformToPlatform<T>>;
export type UniversalOrNative<T extends Platform | Chain> = UniversalAddress | NativeAddress<T>;
export type AccountAddress<T extends Chain | Platform> = UniversalOrNative<T>;
export type TokenAddress<T extends Chain | Platform> = UniversalOrNative<T> | "native";
export type ChainAddress<C extends Chain = Chain> = {
    readonly chain: C;
    readonly address: UniversalOrNative<C>;
};
type NativeAddressCtr = new (ua: UniversalAddress | string | Uint8Array) => Address;
export declare function registerNative<P extends Platform>(platform: P, ctr: NativeAddressCtr): void;
export declare function nativeIsRegistered<T extends Platform | Chain>(chainOrPlatform: T): boolean;
export declare function toNative<T extends Platform | Chain>(chainOrPlatform: T, ua: UniversalAddress | string | Uint8Array): NativeAddress<T>;
export {};
//# sourceMappingURL=address.d.ts.map